# -*- coding: utf-8 -*-

#3a) Si scriva una funzione where_similar(text, pattern, hd_max) che, 
# all'interno della stringa "text", trovi le posizioni delle sottostringhe 
# di lunghezza pari a quella di "pattern" che hanno da "pattern" una distanza 
# di Hamming non superiore a "hd_max".
#
# Es: text = "ambarabaciccicocco"
#     pattern = "cocco"
#     where_similar(text, pattern, 0)  ->  [13]
#     where_similar(text, pattern, 2)  ->  [8, 10, 13]
#     where_similar(text, pattern, 3)  ->  [8, 10, 11, 13]
#     where_similar(text, pattern, 4)  ->  [5, 6, 7, 8, 9, 10, 11, 12, 13]
#     where_similar(text, pattern, 5)  ->  [0, 1, 2, ... 12, 13]



def hdist(s,t):
    return sum(e1!=e2 for e1,e2 in zip(s,t))

def all_windows(s, winlen):     #generator to iterate over adjacent windows
    i, imax = 0, len(s) - winlen
    while i <= imax:
        yield s[i:i+winlen]
        i += 1

def where_similar(text, pattern, hd_max=0):  
    return [ i for i, s in enumerate(all_windows(text, len(pattern))) 
            if hdist(s,pattern) <= hd_max ]
    
        